#ifndef SIGNAL_H
#define SIGNAL_H

#include "item.h"
#include "../microcontroller.h"

class Signal : public Item
{
public:
	static constexpr int GO = 0;
	static constexpr int STOP = 1;
	static constexpr int SLOW = 2;
	static constexpr int EXPECT_GO = 1 << 3;
	static constexpr int EXPECT_STOP = 2 << 3;
	static constexpr int EXPECT_SLOW = 3 << 3;

	static constexpr uint8_t TYPE_NORMAL = 0;
	static constexpr uint8_t TYPE_RELAY = 1;
	static constexpr uint8_t TYPE_HAS_SLOW = 1 << 1;
	static constexpr uint8_t TYPE_HAS_EXPECT = 1 << 2;
private:
	uint8_t subaddress_;
	uint8_t signalId_;
	uint8_t type_;
public:
	static Microcontroller *micro;

	explicit Signal(uint8_t id = 0, uint8_t address = 0, uint8_t subaddress = 0, uint8_t type = 0, int8_t initalValue = 0);
	virtual void setValue(int8_t value);
	bool hasSlow();
	bool hasExpect();
	uint8_t getSignalId()
	{
		return signalId_;
	}
};

#endif // SIGNAL_H
