#ifndef NFCUID_H
#define NFCUID_H
#include <cstdint>
#include <string>

class NfcUid
{
public:
	uint8_t reader;
	uint8_t bytes[10];
	uint8_t length;
	bool operator==(NfcUid& in) const
	{
		if(length != in.length)
			return false;
		for(uint8_t i = 0; i < length; ++i)
		{
			if(bytes[i] != in.bytes[i])
				return false;
		}
		return true;
	}
	bool operator!=(NfcUid& in) const
	{
		return !operator==(in);
	}
	NfcUid(){}
	NfcUid(const uint8_t* const bytesIn, uint8_t lengthIn, uint8_t readerIn = 0):
	reader(readerIn), length(lengthIn)
	{
		for(uint8_t i = 0; i < length; ++i)
			bytes[i] = bytesIn[i];
	}
	std::string toString()
	{
		std::string str;
		for(uint8_t i = 0; i < length; ++i)
		{
			str.append(std::to_string((int)bytes[i]));
			if(i != length-1)
				str.push_back(':');
		}
		return str;
	}
};

#endif // NFCUID_H
